## asmjit 0.0~git20200831.d1b7543

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

cmake_policy(PUSH)

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW) # Honor visibility properties.
endif()

if(POLICY CMP0092)
  cmake_policy(SET CMP0092 NEW) # Don't add -W3 warning level by default.
endif()

include(CheckCXXCompilerFlag)
include(GNUInstallDirs)

# Don't create a project if it was already created by another CMakeLists.txt.
# This allows one library to embed another library without making a collision.
if (NOT CMAKE_PROJECT_NAME OR "${CMAKE_PROJECT_NAME}" STREQUAL "asmjit")
  project(asmjit CXX)
endif()

# =============================================================================
# [AsmJit - Deprecated]
# =============================================================================

if (DEFINED ASMJIT_BUILD_EMBED)
  message(DEPRECATION "ASMJIT_BUILD_EMBED is deprecated, use ASMJIT_EMBED")
  set(ASMJIT_EMBED "${ASMJIT_BUILD_EMBED}")
endif()

if (DEFINED ASMJIT_BUILD_STATIC)
  message(DEPRECATION "ASMJIT_BUILD_STATIC is deprecated, use ASMJIT_STATIC")
  set(ASMJIT_STATIC "${ASMJIT_BUILD_STATIC}")
endif()

# =============================================================================
# [AsmJit - Configuration]
# =============================================================================

if (NOT DEFINED ASMJIT_EMBED)
  set(ASMJIT_EMBED FALSE)
endif()

if (NOT DEFINED ASMJIT_STATIC)
  set(ASMJIT_STATIC ${ASMJIT_EMBED})
endif()

if (NOT DEFINED ASMJIT_BUILD_ARM)
  set(ASMJIT_BUILD_ARM FALSE)
endif()

if (NOT DEFINED ASMJIT_BUILD_X86)
  set(ASMJIT_BUILD_X86 FALSE)
endif()

if (NOT DEFINED ASMJIT_TEST)
  set(ASMJIT_TEST FALSE)
endif()

if (NOT DEFINED ASMJIT_NO_NATVIS)
  set(ASMJIT_NO_NATVIS FALSE)
endif()

# EMBED implies STATIC.
if (ASMJIT_EMBED AND NOT ASMJIT_STATIC)
  set(ASMJIT_STATIC TRUE)
endif()

set(ASMJIT_DIR        "${CMAKE_CURRENT_LIST_DIR}" CACHE PATH "Location of 'asmjit'")
set(ASMJIT_TEST       ${ASMJIT_TEST}              CACHE BOOL "Build 'asmjit' test applications")
set(ASMJIT_EMBED      ${ASMJIT_EMBED}             CACHE BOOL "Embed 'asmjit' library (no targets)")
set(ASMJIT_STATIC     ${ASMJIT_STATIC}            CACHE BOOL "Build 'asmjit' library as static")
set(ASMJIT_SANITIZE   ${ASMJIT_SANITIZE}          CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
set(ASMJIT_BUILD_X86  ${ASMJIT_BUILD_X86}         CACHE BOOL "Build X86 backends (X86 and X86_64)")
set(ASMJIT_BUILD_ARM  ${ASMJIT_BUILD_ARM}         CACHE BOOL "Build ARM backends (ARM/Trumb and AArch64")

# =============================================================================
# [AsmJit - Project]
# =============================================================================

set(ASMJIT_INCLUDE_DIRS "${ASMJIT_DIR}/src")     # Include directory is the same as source dir.
set(ASMJIT_DEPS "")                              # AsmJit dependencies (libraries) for the linker.
set(ASMJIT_LIBS "")                              # Dependencies of libs/apps that want to use AsmJit.
set(ASMJIT_CFLAGS "")                            # Public compiler flags.
set(ASMJIT_PRIVATE_CFLAGS "")                    # Private compiler flags independent of build type.
set(ASMJIT_PRIVATE_CFLAGS_DBG "")                # Private compiler flags used by debug builds.
set(ASMJIT_PRIVATE_CFLAGS_REL "")                # Private compiler flags used by release builds.
set(ASMJIT_SANITIZE_CFLAGS "")                   # Compiler flags required by currently enabled sanitizers.
set(ASMJIT_SANITIZE_LFLAGS "")                   # Linker flags required by currently enabled sanitizers.

# =============================================================================
# [AsmJit - Utilities]
# =============================================================================

function(asmjit_detect_cflags out)
  set(out_array ${${out}})
  foreach(flag ${ARGN})
    string(REGEX REPLACE "[+]" "x" flag_signature "${flag}")
    string(REGEX REPLACE "[-=:;/.\]" "_" flag_signature "${flag_signature}")
    check_cxx_compiler_flag(${flag} "__CxxFlag_${flag_signature}")
    if (${__CxxFlag_${flag_signature}})
      list(APPEND out_array "${flag}")
    endif()
  endforeach()
  set(${out} "${out_array}" PARENT_SCOPE)
endfunction()

# Support for various sanitizers provided by C/C++ compilers.
function(asmjit_detect_sanitizers out)
  set(_out_array ${${out}})
  set(_flags "")

  foreach(_arg ${ARGN})
    string(REPLACE "," ";" _arg "${_arg}")
    list(APPEND _flags ${_arg})
  endforeach()

  foreach(_flag ${_flags})
    if (NOT "${_flag}" MATCHES "^-fsanitize=")
      SET(_flag "-fsanitize=${_flag}")
    endif()

    # Sanitizers also require link flags, see CMAKE_REQUIRED_FLAGS.
    set(CMAKE_REQUIRED_FLAGS "${_flag}")
    asmjit_detect_cflags(_out_array ${_flag})
    unset(CMAKE_REQUIRED_FLAGS)
  endforeach()

  set(${out} "${_out_array}" PARENT_SCOPE)
endfunction()

function(asmjit_add_target target target_type)
  set(single_val "")
  set(multi_val SOURCES LIBRARIES CFLAGS CFLAGS_DBG CFLAGS_REL)
  cmake_parse_arguments("X" "" "${single_val}" "${multi_val}" ${ARGN})

  if ("${target_type}" MATCHES "^(EXECUTABLE|TEST)$")
    add_executable(${target} ${X_SOURCES})
  else()
    add_library(${target} ${target_type} ${X_SOURCES})
  endif()

  target_link_libraries(${target} PRIVATE ${X_LIBRARIES})

  # target_link_options was added in cmake v3.13, don't use it for now...
  foreach(link_flag ${ASMJIT_SANITIZE_LFLAGS})
    set_property(TARGET ${target} APPEND_STRING PROPERTY LINK_FLAGS " ${link_flag}")
  endforeach()

  if (${CMAKE_VERSION} VERSION_LESS "3.8.0")
    set_property(TARGET ${target} PROPERTY CXX_STANDARD 11)
  else()
    target_compile_features(${target} PUBLIC cxx_std_11)
  endif()
  set_property(TARGET ${target} PROPERTY CXX_EXTENSIONS NO)
  set_property(TARGET ${target} PROPERTY CXX_VISIBILITY_PRESET hidden)
  target_compile_options(${target} PRIVATE ${X_CFLAGS} ${ASMJIT_SANITIZE_CFLAGS} $<$<CONFIG:Debug>:${X_CFLAGS_DBG}> $<$<NOT:$<CONFIG:Debug>>:${X_CFLAGS_REL}>)

  if ("${target_type}" STREQUAL "TEST")
    add_test(NAME ${target} COMMAND ${target})
  endif()
endfunction()

# =============================================================================
# [AsmJit - Compiler Support]
# =============================================================================

set(ASMJIT_INCLUDE_DIRS "${ASMJIT_DIR}/src")     # Include directory is the same as source dir.
set(ASMJIT_DEPS "")                              # AsmJit dependencies (libraries) for the linker.
set(ASMJIT_LIBS "")                              # Dependencies of libs/apps that want to use AsmJit.
set(ASMJIT_CFLAGS "")                            # Public compiler flags.
set(ASMJIT_PRIVATE_CFLAGS "")                    # Private compiler flags independent of build type.
set(ASMJIT_PRIVATE_CFLAGS_DBG "")                # Private compiler flags used by debug builds.
set(ASMJIT_PRIVATE_CFLAGS_REL "")                # Private compiler flags used by release builds.
set(ASMJIT_SANITIZE_CFLAGS "")                   # Compiler flags required by currently enabled sanitizers.
set(ASMJIT_SANITIZE_LFLAGS "")                   # Linker flags required by currently enabled sanitizers.

# We will have to keep this most likely forever as some users may still be using it.
set(ASMJIT_INCLUDE_DIR "${ASMJIT_INCLUDE_DIRS}")

if (NOT ASMJIT_NO_CUSTOM_FLAGS)
  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC")
    list(APPEND ASMJIT_PRIVATE_CFLAGS
      -MP                      # [+] Multi-Process Compilation.
      -GF                      # [+] Eliminate duplicate strings.
      -Zc:inline               # [+] Remove unreferenced COMDAT.
      -Zc:strictStrings        # [+] Strict const qualification of string literals.
      -Zc:threadSafeInit-      # [-] Thread-safe statics.
      -W4)                     # [+] Warning level 4.

    list(APPEND ASMJIT_PRIVATE_CFLAGS_DBG
      -GS)                     # [+] Buffer security-check.

    list(APPEND ASMJIT_PRIVATE_CFLAGS_REL
      -GS-                     # [-] Buffer security-check.
      -O2                      # [+] Favor speed over size.
      -Oi)                     # [+] Generate intrinsic functions.
  elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "^(GNU|Clang|AppleClang)$")
    list(APPEND ASMJIT_PRIVATE_CFLAGS -Wall -Wextra -Wconversion)
    list(APPEND ASMJIT_PRIVATE_CFLAGS -fno-math-errno)
    list(APPEND ASMJIT_PRIVATE_CFLAGS_REL -O2)

    asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS
      -fno-threadsafe-statics
      -fno-semantic-interposition)

    # The following flags can save few bytes in the resulting binary.
    asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS_REL
      -fmerge-all-constants    # Merge all constants even if it violates ISO C++.
      -fno-enforce-eh-specs)   # Don't enforce termination if noexcept function throws.
  endif()
endif()

# Support for sanitizers.
if (ASMJIT_SANITIZE)
  ASMJIT_detect_sanitizers(ASMJIT_SANITIZE_CFLAGS ${ASMJIT_SANITIZE})
  if (ASMJIT_SANITIZE_CFLAGS)
    message("-- Enabling sanitizers: '${ASMJIT_SANITIZE_CFLAGS}'")

    # Linker must receive the same flags as the compiler when it comes to sanitizers.
    set(ASMJIT_SANITIZE_LFLAGS ${ASMJIT_SANITIZE_CFLAGS})

    # Don't omit frame pointer if sanitizers are enabled.
    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC")
      list(APPEND ASMJIT_SANITIZE_CFLAGS -Oy-)
    else()
      list(APPEND ASMJIT_SANITIZE_CFLAGS -fno-omit-frame-pointer -g)
    endif()

    list(APPEND ASMJIT_PRIVATE_CFLAGS ${ASMJIT_SANITIZE_CFLAGS})
    list(APPEND ASMJIT_PRIVATE_LFLAGS ${ASMJIT_SANITIZE_LFLAGS})
  endif()
endif()

if (NOT WIN32)
  list(APPEND ASMJIT_DEPS pthread)
endif()

if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
  list(APPEND ASMJIT_DEPS rt)
endif()

set(ASMJIT_LIBS ${ASMJIT_DEPS})
if (NOT ASMJIT_EMBED)
  list(INSERT ASMJIT_LIBS 0 asmjit)
endif()

if (ASMJIT_EMBED)
  set(ASMJIT_TARGET_TYPE "EMBED")
elseif (ASMJIT_STATIC)
  set(ASMJIT_TARGET_TYPE "STATIC")
else()
  set(ASMJIT_TARGET_TYPE "SHARED")
endif()

foreach(build_option ASMJIT_STATIC
                     ASMJIT_BUILD_X86
                     #ASMJIT_BUILD_ARM
                     ASMJIT_BUILD_A64
                     ASMJIT_NO_DEPRECATED
                     ASMJIT_NO_JIT
                     ASMJIT_NO_LOGGING
                     ASMJIT_NO_BUILDER
                     ASMJIT_NO_COMPILER
                     ASMJIT_NO_TEXT
                     ASMJIT_NO_VALIDATION
                     ASMJIT_NO_INTROSPECTION)
  if (${build_option})
    List(APPEND ASMJIT_CFLAGS         "-D${build_option}")
    List(APPEND ASMJIT_PRIVATE_CFLAGS "-D${build_option}")
  endif()
endforeach()

# =============================================================================
# [AsmJit - Linker Support]
# =============================================================================

if (WIN32)
  if(CMAKE_LINKER MATCHES "link\\.exe" OR CMAKE_LINKER MATCHES "lld-link\\.exe")
    set(ASMJIT_LINKER_SUPPORTS_NATVIS TRUE)
  endif()
endif()

# =============================================================================
# [AsmJit - Source]
# =============================================================================

set(ASMJIT_SRC_LIST
  asmjit/asmjit.h

  asmjit/core.h
  asmjit/core/api-build_p.h
  asmjit/core/api-config.h
  asmjit/core/arch.cpp
  asmjit/core/arch.h
  asmjit/core/assembler.cpp
  asmjit/core/assembler.h
  asmjit/core/builder.cpp
  asmjit/core/builder.h
  asmjit/core/callconv.cpp
  asmjit/core/callconv.h
  asmjit/core/codebuffer.h
  asmjit/core/codebufferwriter_p.h
  asmjit/core/codeholder.cpp
  asmjit/core/codeholder.h
  asmjit/core/compiler.cpp
  asmjit/core/compiler.h
  asmjit/core/constpool.cpp
  asmjit/core/constpool.h
  asmjit/core/cpuinfo.cpp
  asmjit/core/cpuinfo.h
  asmjit/core/datatypes.h
  asmjit/core/emitter.cpp
  asmjit/core/emitter.h
  asmjit/core/emitterutils.cpp
  asmjit/core/emitterutils_p.h
  asmjit/core/environment.cpp

=== debian/changelog ===
asmjit (0.0~git20200831.d1b7543-1) unstable; urgency=medium

  * New upstream version 0.0~git20200831.d1b7543
  * Patch upstream CMake, adding the SOVERSION property to shlibs.
  * Nolonger install the static library.
  * Install CMake config files to the -devel package.
  * Remove the symbols control file.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Sep 2020 13:33:50 +0800

asmjit (0.0~git20200429.9057aa3-1) experimental; urgency=medium

  * Initial Release (Closes: #958516)

 -- Yangfl <mmyangfl@gmail.com>  Tue, 13 Aug 2019 14:59:22 +0800

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND =

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DASMJIT_TEST=ON -DASMJIT_BUILD_X86=ON -DASMJIT_BUILD_ARM=ON

## asmjit 0.0~git20201108.4b13f71

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,9 +9,6 @@
 if(POLICY CMP0092)
   cmake_policy(SET CMP0092 NEW) # Don't add -W3 warning level by default.
 endif()
-
-include(CheckCXXCompilerFlag)
-include(GNUInstallDirs)
 
 # Don't create a project if it was already created by another CMakeLists.txt.
 # This allows one library to embed another library without making a collision.
@@ -19,6 +16,9 @@
   project(asmjit CXX)
 endif()
 
+include(CheckCXXCompilerFlag)
+include(GNUInstallDirs)
+
 # =============================================================================
 # [AsmJit - Deprecated]
 # =============================================================================
@@ -43,10 +43,6 @@
 
 if (NOT DEFINED ASMJIT_STATIC)
   set(ASMJIT_STATIC ${ASMJIT_EMBED})
-endif()
-
-if (NOT DEFINED ASMJIT_BUILD_ARM)
-  set(ASMJIT_BUILD_ARM FALSE)
 endif()
 
 if (NOT DEFINED ASMJIT_BUILD_X86)
@@ -72,7 +68,6 @@
 set(ASMJIT_STATIC     ${ASMJIT_STATIC}            CACHE BOOL "Build 'asmjit' library as static")
 set(ASMJIT_SANITIZE   ${ASMJIT_SANITIZE}          CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
 set(ASMJIT_BUILD_X86  ${ASMJIT_BUILD_X86}         CACHE BOOL "Build X86 backends (X86 and X86_64)")
-set(ASMJIT_BUILD_ARM  ${ASMJIT_BUILD_ARM}         CACHE BOOL "Build ARM backends (ARM/Trumb and AArch64")
 
 # =============================================================================
 # [AsmJit - Project]
@@ -140,6 +135,7 @@
     add_library(${target} ${target_type} ${X_SOURCES})
   endif()
 
+  set_target_properties(${target} PROPERTIES DEFINE_SYMBOL "")
   target_link_libraries(${target} PRIVATE ${X_LIBRARIES})
 
   # target_link_options was added in cmake v3.13, don't use it for now...
@@ -236,7 +232,7 @@
   list(APPEND ASMJIT_DEPS pthread)
 endif()
 
-if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
+if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux" OR "${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
   list(APPEND ASMJIT_DEPS rt)
 endif()
 
@@ -255,8 +251,6 @@
 
 foreach(build_option ASMJIT_STATIC
                      ASMJIT_BUILD_X86
-                     #ASMJIT_BUILD_ARM
-                     ASMJIT_BUILD_A64
                      ASMJIT_NO_DEPRECATED
                      ASMJIT_NO_JIT
                      ASMJIT_NO_LOGGING
@@ -287,29 +281,34 @@
 
 set(ASMJIT_SRC_LIST
   asmjit/asmjit.h
+  asmjit/asmjit-scope-begin.h
+  asmjit/asmjit-scope-end.h
 
   asmjit/core.h
   asmjit/core/api-build_p.h
   asmjit/core/api-config.h
-  asmjit/core/arch.cpp
-  asmjit/core/arch.h
+  asmjit/core/archtraits.cpp
+  asmjit/core/archtraits.h
+  asmjit/core/archcommons.h
   asmjit/core/assembler.cpp
   asmjit/core/assembler.h
   asmjit/core/builder.cpp
   asmjit/core/builder.h
-  asmjit/core/callconv.cpp
-  asmjit/core/callconv.h
   asmjit/core/codebuffer.h
-  asmjit/core/codebufferwriter_p.h
   asmjit/core/codeholder.cpp
   asmjit/core/codeholder.h
+  asmjit/core/codewriter.cpp
+  asmjit/core/codewriter_p.h
   asmjit/core/compiler.cpp
   asmjit/core/compiler.h
+  asmjit/core/compilerdefs.h
   asmjit/core/constpool.cpp
   asmjit/core/constpool.h
   asmjit/core/cpuinfo.cpp
   asmjit/core/cpuinfo.h
   asmjit/core/datatypes.h
+  asmjit/core/emithelper.cpp
+  asmjit/core/emithelper_p.h
   asmjit/core/emitter.cpp
   asmjit/core/emitter.h
   asmjit/core/emitterutils.cpp

=== debian/changelog ===
asmjit (0.0~git20201108.4b13f71-1) unstable; urgency=medium

  * New upstream version 0.0~git20201108.4b13f71
  * Specify CMAKE_VERBOSE_MAKEFILE=ON.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Dec 2020 20:28:12 +0800

=== debian/control ===
Source: asmjit
Priority: optional
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yangfl <mmyangfl@gmail.com>, Mo Zhou <lumin@debian.org>
Build-Depends: cmake, debhelper-compat (= 13)
Rules-Requires-Root: no
Standards-Version: 4.5.0
Section: libs
Vcs-Browser: https://salsa.debian.org/deeplearning-team/asmjit
Vcs-Git: https://salsa.debian.org/deeplearning-team/asmjit.git
Homepage: https://github.com/asmjit/asmjit

Package: libasmjit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libasmjit0 (= ${binary:Version}), ${misc:Depends}
Description: Complete x86/x64 JIT and AOT Assembler for C++ (development files)
 AsmJit is a complete JIT and AOT assembler for C++ language. It can generate
 native code for x86 and x64 architectures and supports the whole x86/x64
 instruction set - from legacy MMX to the newest AVX512. It has a type-safe API
 that allows C++ compiler to do semantic checks at compile-time even before the
 assembled code is generated and/or executed.
 .
 This package contains the header files and the static library.

Package: libasmjit0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Complete x86/x64 JIT and AOT Assembler for C++
 AsmJit is a complete JIT and AOT assembler for C++ language. It can generate
 native code for x86 and x64 architectures and supports the whole x86/x64
 instruction set - from legacy MMX to the newest AVX512. It has a type-safe API
 that allows C++ compiler to do semantic checks at compile-time even before the
 assembled code is generated and/or executed.

=== debian/rules ===
--- 
+++ 
@@ -8,4 +8,4 @@
 	dh $@
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DASMJIT_TEST=ON -DASMJIT_BUILD_X86=ON -DASMJIT_BUILD_ARM=ON
+	dh_auto_configure -- -DASMJIT_TEST=ON -DASMJIT_BUILD_X86=ON -DASMJIT_BUILD_ARM=ON -DCMAKE_VERBOSE_MAKEFILE=ON

## asmjit 0.0~git20211214.2a706fd

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,8 @@
 include(CheckCXXCompilerFlag)
 include(GNUInstallDirs)
 
-# =============================================================================
-# [AsmJit - Deprecated]
-# =============================================================================
+# AsmJit - Deprecated
+# ===================
 
 if (DEFINED ASMJIT_BUILD_EMBED)
   message(DEPRECATION "ASMJIT_BUILD_EMBED is deprecated, use ASMJIT_EMBED")
@@ -33,9 +32,12 @@
   set(ASMJIT_STATIC "${ASMJIT_BUILD_STATIC}")
 endif()
 
-# =============================================================================
-# [AsmJit - Configuration]
-# =============================================================================
+# AsmJit - Configuration
+# ======================
+
+if (NOT DEFINED ASMJIT_TEST)
+  set(ASMJIT_TEST FALSE)
+endif()
 
 if (NOT DEFINED ASMJIT_EMBED)
   set(ASMJIT_EMBED FALSE)
@@ -45,16 +47,24 @@
   set(ASMJIT_STATIC ${ASMJIT_EMBED})
 endif()
 
-if (NOT DEFINED ASMJIT_BUILD_X86)
-  set(ASMJIT_BUILD_X86 FALSE)
-endif()
-
-if (NOT DEFINED ASMJIT_TEST)
-  set(ASMJIT_TEST FALSE)
+if (NOT DEFINED ASMJIT_SANITIZE)
+  set(ASMJIT_SANITIZE FALSE)
+endif()
+
+if (NOT DEFINED ASMJIT_NO_X86)
+  set(ASMJIT_NO_X86 FALSE)
+endif()
+
+if (NOT DEFINED ASMJIT_NO_FOREIGN)
+  set(ASMJIT_NO_FOREIGN FALSE)
 endif()
 
 if (NOT DEFINED ASMJIT_NO_NATVIS)
   set(ASMJIT_NO_NATVIS FALSE)
+endif()
+
+if (NOT DEFINED ASMJIT_NO_CUSTOM_FLAGS)
+  set(ASMJIT_NO_CUSTOM_FLAGS FALSE)
 endif()
 
 # EMBED implies STATIC.
@@ -62,16 +72,18 @@
   set(ASMJIT_STATIC TRUE)
 endif()
 
-set(ASMJIT_DIR        "${CMAKE_CURRENT_LIST_DIR}" CACHE PATH "Location of 'asmjit'")
-set(ASMJIT_TEST       ${ASMJIT_TEST}              CACHE BOOL "Build 'asmjit' test applications")
-set(ASMJIT_EMBED      ${ASMJIT_EMBED}             CACHE BOOL "Embed 'asmjit' library (no targets)")
-set(ASMJIT_STATIC     ${ASMJIT_STATIC}            CACHE BOOL "Build 'asmjit' library as static")
-set(ASMJIT_SANITIZE   ${ASMJIT_SANITIZE}          CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
-set(ASMJIT_BUILD_X86  ${ASMJIT_BUILD_X86}         CACHE BOOL "Build X86 backends (X86 and X86_64)")
-
-# =============================================================================
-# [AsmJit - Project]
-# =============================================================================
+set(ASMJIT_DIR             "${CMAKE_CURRENT_LIST_DIR}" CACHE PATH "Location of 'asmjit'")
+set(ASMJIT_TEST            "${ASMJIT_TEST}"            CACHE BOOL "Build 'asmjit' test applications")
+set(ASMJIT_EMBED           "${ASMJIT_EMBED}"           CACHE BOOL "Embed 'asmjit' library (no targets)")
+set(ASMJIT_STATIC          "${ASMJIT_STATIC}"          CACHE BOOL "Build 'asmjit' library as static")
+set(ASMJIT_SANITIZE        "${ASMJIT_SANITIZE}"        CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
+set(ASMJIT_NO_X86          "${ASMJIT_NO_X86}"          CACHE BOOL "Disable X86/X64 backend")
+set(ASMJIT_NO_FOREIGN      "${ASMJIT_NO_FOREIGN}"      CACHE BOOL "Disable all foreign architectures (builds only host backend)")
+set(ASMJIT_NO_NATVIS       "${ASMJIT_NO_NATVIS}"       CACHE BOOL "Disable natvis support (embedding asmjit.natvis in PDB)")
+set(ASMJIT_NO_CUSTOM_FLAGS "${ASMJIT_NO_CUSTOM_FLAGS}" CACHE BOOL "Disable extra compilation flags added by AsmJit to its targets")
+
+# AsmJit - Project
+# ================
 
 set(ASMJIT_INCLUDE_DIRS "${ASMJIT_DIR}/src")     # Include directory is the same as source dir.
 set(ASMJIT_DEPS "")                              # AsmJit dependencies (libraries) for the linker.
@@ -83,9 +95,8 @@
 set(ASMJIT_SANITIZE_CFLAGS "")                   # Compiler flags required by currently enabled sanitizers.
 set(ASMJIT_SANITIZE_LFLAGS "")                   # Linker flags required by currently enabled sanitizers.
 
-# =============================================================================
-# [AsmJit - Utilities]
-# =============================================================================
+# AsmJit - Utilities
+# ==================
 
 function(asmjit_detect_cflags out)
   set(out_array ${${out}})
@@ -157,9 +168,8 @@
   endif()
 endfunction()
 
-# =============================================================================
-# [AsmJit - Compiler Support]
-# =============================================================================
+# AsmJit - Compiler Support
+# =========================
 
 set(ASMJIT_INCLUDE_DIRS "${ASMJIT_DIR}/src")     # Include directory is the same as source dir.
 set(ASMJIT_DEPS "")                              # AsmJit dependencies (libraries) for the linker.
@@ -250,7 +260,10 @@
 endif()
 
 foreach(build_option ASMJIT_STATIC
-                     ASMJIT_BUILD_X86
+                     # AsmJit backends selection.
+                     ASMJIT_NO_X86
+                     ASMJIT_NO_FOREIGN
+                     # AsmJit features selection.
                      ASMJIT_NO_DEPRECATED
                      ASMJIT_NO_JIT
                      ASMJIT_NO_LOGGING
@@ -265,9 +278,8 @@
   endif()
 endforeach()
 
-# =============================================================================
-# [AsmJit - Linker Support]
-# =============================================================================
+# AsmJit - Linker Support
+# =======================
 
 if (WIN32)
   if(CMAKE_LINKER MATCHES "link\\.exe" OR CMAKE_LINKER MATCHES "lld-link\\.exe")
@@ -275,9 +287,8 @@
   endif()
 endif()
 
-# =============================================================================
-# [AsmJit - Source]
-# =============================================================================
+# AsmJit - Source
+# ===============
 
 set(ASMJIT_SRC_LIST
   asmjit/asmjit.h
@@ -306,7 +317,6 @@
   asmjit/core/constpool.h
   asmjit/core/cpuinfo.cpp
   asmjit/core/cpuinfo.h
-  asmjit/core/datatypes.h
   asmjit/core/emithelper.cpp
   asmjit/core/emithelper_p.h
   asmjit/core/emitter.cpp
@@ -314,3 +324,11 @@
   asmjit/core/emitterutils.cpp
   asmjit/core/emitterutils_p.h
   asmjit/core/environment.cpp
+  asmjit/core/environment.h
+  asmjit/core/errorhandler.cpp
+  asmjit/core/errorhandler.h
+  asmjit/core/formatter.cpp
+  asmjit/core/formatter.h
+  asmjit/core/func.cpp
+  asmjit/core/func.h
+  asmjit/core/funcargscontext.cpp

=== debian/changelog ===
asmjit (0.0~git20211214.2a706fd-1) unstable; urgency=medium

  * New upstream version 0.0~git20211214.2a706fd (Closes: #983973)

 -- Mo Zhou <lumin@debian.org>  Mon, 10 Jan 2022 00:14:49 -0500

## asmjit 0.0~git20221210.5b5b0b3

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,14 @@
 
 if (NOT DEFINED ASMJIT_NO_X86)
   set(ASMJIT_NO_X86 FALSE)
+endif()
+
+if (NOT DEFINED ASMJIT_NO_AARCH32)
+  set(ASMJIT_NO_AARCH32 FALSE)
+endif()
+
+if (NOT DEFINED ASMJIT_NO_AARCH64)
+  set(ASMJIT_NO_AARCH64 FALSE)
 endif()
 
 if (NOT DEFINED ASMJIT_NO_FOREIGN)
@@ -78,7 +86,9 @@
 set(ASMJIT_STATIC          "${ASMJIT_STATIC}"          CACHE BOOL "Build 'asmjit' library as static")
 set(ASMJIT_SANITIZE        "${ASMJIT_SANITIZE}"        CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
 set(ASMJIT_NO_X86          "${ASMJIT_NO_X86}"          CACHE BOOL "Disable X86/X64 backend")
-set(ASMJIT_NO_FOREIGN      "${ASMJIT_NO_FOREIGN}"      CACHE BOOL "Disable all foreign architectures (builds only host backend)")
+set(ASMJIT_NO_AARCH32      "${ASMJIT_NO_AARCH32}"      CACHE BOOL "Disable AArch32 backend (ARM and THUMB)")
+set(ASMJIT_NO_AARCH64      "${ASMJIT_NO_AARCH64}"      CACHE BOOL "Disable AArch64 backend")
+set(ASMJIT_NO_FOREIGN      "${ASMJIT_NO_FOREIGN}"      CACHE BOOL "Disable all foreign architectures (enables only a native architecture)")
 set(ASMJIT_NO_NATVIS       "${ASMJIT_NO_NATVIS}"       CACHE BOOL "Disable natvis support (embedding asmjit.natvis in PDB)")
 set(ASMJIT_NO_CUSTOM_FLAGS "${ASMJIT_NO_CUSTOM_FLAGS}" CACHE BOOL "Disable extra compilation flags added by AsmJit to its targets")
 
@@ -185,10 +195,11 @@
 set(ASMJIT_INCLUDE_DIR "${ASMJIT_INCLUDE_DIRS}")
 
 if (NOT ASMJIT_NO_CUSTOM_FLAGS)
-  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC")
+  if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_COMPILER_FRONTEND_VARIANT}" STREQUAL "xMSVC")
     list(APPEND ASMJIT_PRIVATE_CFLAGS
       -MP                      # [+] Multi-Process Compilation.
       -GF                      # [+] Eliminate duplicate strings.
+      -Zc:__cplusplus          # [+] Conforming __cplusplus definition.
       -Zc:inline               # [+] Remove unreferenced COMDAT.
       -Zc:strictStrings        # [+] Strict const qualification of string literals.
       -Zc:threadSafeInit-      # [-] Thread-safe statics.
@@ -227,7 +238,7 @@
     set(ASMJIT_SANITIZE_LFLAGS ${ASMJIT_SANITIZE_CFLAGS})
 
     # Don't omit frame pointer if sanitizers are enabled.
-    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_SIMULATE_ID}" STREQUAL "xMSVC")
+    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC" OR "x${CMAKE_CXX_COMPILER_FRONTEND_VARIANT}" STREQUAL "xMSVC")
       list(APPEND ASMJIT_SANITIZE_CFLAGS -Oy-)
     else()
       list(APPEND ASMJIT_SANITIZE_CFLAGS -fno-omit-frame-pointer -g)
@@ -238,7 +249,8 @@
   endif()
 endif()
 
-if (NOT WIN32)
+# Do not link to pthread on Android as it's part of C runtime.
+if (NOT WIN32 AND NOT ANDROID)
   list(APPEND ASMJIT_DEPS pthread)
 endif()
 
@@ -262,6 +274,8 @@
 foreach(build_option ASMJIT_STATIC
                      # AsmJit backends selection.
                      ASMJIT_NO_X86
+                     ASMJIT_NO_AARCH32
+                     ASMJIT_NO_AARCH64
                      ASMJIT_NO_FOREIGN
                      # AsmJit features selection.
                      ASMJIT_NO_DEPRECATED
@@ -310,25 +324,3 @@
   asmjit/core/codeholder.h
   asmjit/core/codewriter.cpp
   asmjit/core/codewriter_p.h
-  asmjit/core/compiler.cpp
-  asmjit/core/compiler.h
-  asmjit/core/compilerdefs.h
-  asmjit/core/constpool.cpp
-  asmjit/core/constpool.h
-  asmjit/core/cpuinfo.cpp
-  asmjit/core/cpuinfo.h
-  asmjit/core/emithelper.cpp
-  asmjit/core/emithelper_p.h
-  asmjit/core/emitter.cpp
-  asmjit/core/emitter.h
-  asmjit/core/emitterutils.cpp
-  asmjit/core/emitterutils_p.h
-  asmjit/core/environment.cpp
-  asmjit/core/environment.h
-  asmjit/core/errorhandler.cpp
-  asmjit/core/errorhandler.h
-  asmjit/core/formatter.cpp
-  asmjit/core/formatter.h
-  asmjit/core/func.cpp
-  asmjit/core/func.h
-  asmjit/core/funcargscontext.cpp

=== debian/changelog ===
asmjit (0.0~git20221210.5b5b0b3-1) unstable; urgency=medium

  * New upstream version 0.0~git20221210.5b5b0b3
  * New maintainer (Closes: #1013214)
  * Drop artificial shared library, build shared library.
  * Set upstream metadata fields: Bug-Database.
  * Update standards version to 4.6.1, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Tue, 20 Dec 2022 02:46:28 -0500

asmjit (0.0~git20221018.8f2c237-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20221018.8f2c237 (Closes: #1021055)

 -- Andrius Merkys <merkys@debian.org>  Mon, 24 Oct 2022 10:48:04 -0400

=== debian/control ===
Source: asmjit
Priority: optional
Maintainer: Debian Deep Learning Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Yangfl <mmyangfl@gmail.com>,
 Mo Zhou <lumin@debian.org>,
 Andrius Merkys <merkys@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
Rules-Requires-Root: no
Standards-Version: 4.6.1
Section: libs
Vcs-Browser: https://salsa.debian.org/deeplearning-team/asmjit
Vcs-Git: https://salsa.debian.org/deeplearning-team/asmjit.git
Homepage: https://github.com/asmjit/asmjit

Package: libasmjit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description: Complete x86/x64 JIT and AOT Assembler for C++ (development files)
 AsmJit is a complete JIT and AOT assembler for C++ language. It can generate
 native code for x86 and x64 architectures and supports the whole x86/x64
 instruction set - from legacy MMX to the newest AVX512. It has a type-safe API
 that allows C++ compiler to do semantic checks at compile-time even before the
 assembled code is generated and/or executed.

## asmjit 0.0~git20230818.1591915

=== debian/changelog ===
asmjit (0.0~git20230818.1591915-1) unstable; urgency=medium

  * New upstream version 0.0~git20230818.1591915

 -- Andrius Merkys <merkys@debian.org>  Mon, 04 Sep 2023 04:06:08 -0400

asmjit (0.0~git20230427.3577608-1) unstable; urgency=medium

  * New upstream version 0.0~git20230427.3577608
  * Update standards version to 4.6.2, no changes needed.
  * Add myself to debian/copyright.

 -- Andrius Merkys <merkys@debian.org>  Tue, 20 Jun 2023 06:07:50 -0400

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
  cmake,
  debhelper-compat (= 13),
 Rules-Requires-Root: no
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/asmjit
 Vcs-Git: https://salsa.debian.org/deeplearning-team/asmjit.git

## asmjit 0.0~git20231115.1da9e4d

=== CMakeLists.txt ===
--- 
+++ 
@@ -53,10 +53,6 @@
 
 if (NOT DEFINED ASMJIT_NO_X86)
   set(ASMJIT_NO_X86 FALSE)
-endif()
-
-if (NOT DEFINED ASMJIT_NO_AARCH32)
-  set(ASMJIT_NO_AARCH32 FALSE)
 endif()
 
 if (NOT DEFINED ASMJIT_NO_AARCH64)
@@ -86,7 +82,6 @@
 set(ASMJIT_STATIC          "${ASMJIT_STATIC}"          CACHE BOOL "Build 'asmjit' library as static")
 set(ASMJIT_SANITIZE        "${ASMJIT_SANITIZE}"        CACHE STRING "Build with sanitizers: 'address', 'undefined', etc...")
 set(ASMJIT_NO_X86          "${ASMJIT_NO_X86}"          CACHE BOOL "Disable X86/X64 backend")
-set(ASMJIT_NO_AARCH32      "${ASMJIT_NO_AARCH32}"      CACHE BOOL "Disable AArch32 backend (ARM and THUMB)")
 set(ASMJIT_NO_AARCH64      "${ASMJIT_NO_AARCH64}"      CACHE BOOL "Disable AArch64 backend")
 set(ASMJIT_NO_FOREIGN      "${ASMJIT_NO_FOREIGN}"      CACHE BOOL "Disable all foreign architectures (enables only a native architecture)")
 set(ASMJIT_NO_NATVIS       "${ASMJIT_NO_NATVIS}"       CACHE BOOL "Disable natvis support (embedding asmjit.natvis in PDB)")
@@ -217,9 +212,12 @@
     list(APPEND ASMJIT_PRIVATE_CFLAGS -fno-math-errno)
     list(APPEND ASMJIT_PRIVATE_CFLAGS_REL -O2)
 
-    asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS
-      -fno-threadsafe-statics
-      -fno-semantic-interposition)
+    # -fno-semantic-interposition is not available on apple - the compiler issues a warning, which is not detected.
+    if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
+      asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS -fno-threadsafe-statics)
+    else()
+      asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS -fno-threadsafe-statics -fno-semantic-interposition)
+    endif()
 
     # The following flags can save few bytes in the resulting binary.
     asmjit_detect_cflags(ASMJIT_PRIVATE_CFLAGS_REL
@@ -274,7 +272,6 @@
 foreach(build_option ASMJIT_STATIC
                      # AsmJit backends selection.
                      ASMJIT_NO_X86
-                     ASMJIT_NO_AARCH32
                      ASMJIT_NO_AARCH64
                      ASMJIT_NO_FOREIGN
                      # AsmJit features selection.
@@ -323,4 +320,3 @@
   asmjit/core/codeholder.cpp
   asmjit/core/codeholder.h
   asmjit/core/codewriter.cpp
-  asmjit/core/codewriter_p.h

=== debian/changelog ===
asmjit (0.0~git20231115.1da9e4d-2~exp1) experimental; urgency=medium

  * Limit architectures to 64bit by build-depending on architecture-is-64-bit.

 -- Andrius Merkys <merkys@debian.org>  Tue, 19 Mar 2024 02:48:42 -0400

asmjit (0.0~git20231115.1da9e4d-1) unstable; urgency=medium

  * New upstream version 0.0~git20231115.1da9e4d

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Nov 2023 10:25:17 -0500

asmjit (0.0~git20230914.917f19d-1) unstable; urgency=medium

  * New upstream version 0.0~git20230914.917f19d
  * Do not build on armel and armhf.

 -- Andrius Merkys <merkys@debian.org>  Thu, 28 Sep 2023 03:10:50 -0400

asmjit (0.0~git20230911.46bdb67-1) unstable; urgency=medium

  * New upstream version 0.0~git20230911.46bdb67

 -- Andrius Merkys <merkys@debian.org>  Wed, 13 Sep 2023 03:34:20 -0400

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
  Mo Zhou <lumin@debian.org>,
  Andrius Merkys <merkys@debian.org>,
 Build-Depends:
+ architecture-is-64-bit,
  cmake,
  debhelper-compat (= 13),
 Rules-Requires-Root: no

=== debian/tests/control ===
Tests: unittest.sh
Depends:
 @builddeps@,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/asmjit/asmjit \
HEAD debian uupdate
